<template>
	<xn-form-container
		:title="formData.id ? '编辑蛋糕券配置' : '增加蛋糕券配置'"
		:width="700"
		v-model:open="open"
		:destroy-on-close="true"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
			<a-form-item label="充值方案id：" name="rechargePlanId">
				<a-input v-model:value="formData.rechargePlanId" placeholder="请输入充值方案id" allow-clear />
			</a-form-item>
			<a-form-item label="蛋糕券金额：" name="couponAmount">
				<a-input v-model:value="formData.couponAmount" placeholder="请输入蛋糕券金额" allow-clear />
			</a-form-item>
			<a-form-item label="类型：1：寸  2：元：" name="couponType">
				<a-input v-model:value="formData.couponType" placeholder="请输入类型：1：寸  2：元" allow-clear />
			</a-form-item>
			<a-form-item label="蛋糕券数量：" name="couponNum">
				<a-input v-model:value="formData.couponNum" placeholder="请输入蛋糕券数量" allow-clear />
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</xn-form-container>
</template>

<script setup name="couponConfigForm">
	import { cloneDeep } from 'lodash-es'
	import { required } from '@/utils/formRules'
	import couponConfigApi from '@/api/biz/couponConfigApi'
	// 抽屉状态
	const open = ref(false)
	const emit = defineEmits({ successful: null })
	const formRef = ref()
	// 表单数据
	const formData = ref({})
	const submitLoading = ref(false)

	// 打开抽屉
	const onOpen = (record) => {
		open.value = true
		if (record) {
			let recordData = cloneDeep(record)
			formData.value = Object.assign({}, recordData)
		}
	}
	// 关闭抽屉
	const onClose = () => {
		formRef.value.resetFields()
		formData.value = {}
		open.value = false
	}
	// 默认要校验的
	const formRules = {
	}
	// 验证并提交数据
	const onSubmit = () => {
		formRef.value
			.validate()
			.then(() => {
				submitLoading.value = true
				const formDataParam = cloneDeep(formData.value)
				couponConfigApi
					.couponConfigSubmitForm(formDataParam, formDataParam.id)
					.then(() => {
						onClose()
						emit('successful')
					})
					.finally(() => {
						submitLoading.value = false
					})
			})
			.catch(() => {})
	}
	// 抛出函数
	defineExpose({
		onOpen
	})
</script>
